︠13e66bfb-37ae-4a7c-8fc3-1a8b028b1557i︠
%md
## Chapter 4 - Primes ##
︡bd544277-57bb-4bf4-a3d0-89fc42724bec︡{"md":"## Chapter 4 - Primes ##\n"}︡
︠bb7b5ab2-53f3-4336-a8c8-b943c8a179bfi︠
%md
#### Algorithm 4.3 (Sieve of Eratosthenes) ####
︡68256151-cf68-4bc7-9bd2-6ea8ec5cbb4a︡{"md":"#### Algorithm 4.3 (Sieve of Eratosthenes) ####\n"}︡
︠8f74918c-d815-4c8e-917d-fe53097f279ai︠
%md
The function defined below implements Algorithm 4.3.  Note that Sage identifies the first element in a list as being in position 0.  Thus, we have set our initial list of numbers to be sieved to start at 0 so that number k is in the k-th position of the list.  We `cross out' an element of S by setting it equal to 0.  The list P is obtained by picking off the positions in S (other than 1) that contain a nonzero entry
︡06f6b456-da1e-428e-ae47-c24f016e7c55︡︡{"done":true,"md":"The function defined below implements Algorithm 4.3.  Note that Sage identifies the first element in a list as being in position 0.  Thus, we have set our initial list of numbers to be sieved to start at 0 so that number k is in the k-th position of the list.  We `cross out' an element of S by setting it equal to 0.  The list P is obtained by picking off the positions in S (other than 1) that contain a nonzero entry"}
︠4ad2c72a-65f2-45db-af25-b2af0261f64b︠

︡56c6431c-ddf4-4e40-bc10-9f336b15275d︡
︠32c82ed4-fd91-4929-a569-2b687dc8a71a︠
def sieve(n):
    S=[0..n]
    P=[]
    d=floor(sqrt(n))
    for i in [2..d]:
        if S[i]!=0:
            j=2*i;
            while j <= n:
                S[j]=0
                j=j+i
        i=i+1
    for i in [2..n]:
        if S[i]!=0:
            P.append(i)    
    return(P)
︡2459d6ea-0f9f-4273-a9cc-e10e2b1799cb︡
︠c03551a5-d903-4b9e-b048-630e2dd2e41a︠
sieve(100)
︡c9b0a169-cbca-45bd-9f50-2e5b561e3df8︡{"stdout":"[2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97]\n"}︡
︠02b4d0bc-1287-4ba5-b063-c046da83c124i︠
%md
#### Prime Factorization ####
︡b04acebc-d852-42d3-afa7-cc0147e628ba︡{"md":"#### Prime Factorization ####\n"}︡
︠ce57e25a-dcfa-4c65-8b4a-cc98f2bba6d3i︠
%md 
The command **factor(n)** produces the prime factorization of n.
︡662d3abc-b1aa-4d71-9e19-fc353b9ca80f︡{"md":"The command **factor(n)** produces the prime factorization of n.\n"}︡
︠1b91b044-599c-48c2-80e4-4870a9095612︠
factor(100)            
︡6d50c4f5-1767-49cc-bd74-e7f4ec50a3bd︡{"stdout":"2^2 * 5^2\n"}︡
︠89164250-82c6-4190-b17a-c765f8808495i︠
%md
#### The Prime Number Theorem ####
︡5db3b297-8124-41d6-a345-620d5d8da247︡{"md":"#### The Prime Number Theorem ####\n"}︡
︠9f3bce4f-c829-4da3-b99e-5e20d62d9b45︠
︡62784012-3c6a-4d48-ab66-8cf9affdc2c7︡{"md":"Table 4.1\n"}︡
︠b3911d7f-0a65-403e-9002-b762c2e43d59︠
table([(10^n,prime_pi(10^n),N(10^n/log(10^n)),N(prime_pi(10^n)/(10^n/log(10^n)))) for n in [1..6]], header_row=["x", "pi(x)","x/log(x)","pi(x)/(x/log(x))"], frame=True)
︡ebe3b9fd-ab6e-4fc7-861d-ae2b776c721b︡{"stdout":"+---------+-------+------------------+-------------------+\n| x       | pi(x) | x/log(x)         | pi(x)/(x/log(x))  |\n+=========+=======+==================+===================+\n| 10      | 4     | 4.34294481903252 | 0.921034037197618 |\n+---------+-------+------------------+-------------------+\n| 100     | 25    | 21.7147240951626 | 1.15129254649702  |\n+---------+-------+------------------+-------------------+\n| 1000    | 168   | 144.764827301084 | 1.16050288686900  |\n+---------+-------+------------------+-------------------+\n| 10000   | 1229  | 1085.73620475813 | 1.13195083171587  |\n+---------+-------+------------------+-------------------+\n| 100000  | 9592  | 8685.88963806504 | 1.10431981059994  |\n+---------+-------+------------------+-------------------+\n| 1000000 | 78498 | 72382.4136505420 | 1.08448994777908  |\n+---------+-------+------------------+-------------------+\n"}︡
︠e44f25b6-af58-42d8-9a62-0684f5fe0d56︠









